#include <stdio.h>
#include <stdlib.h>

int main(void) {
	//	A and B have same values but opposite signs
	float A = -500000000.f;
	float B = 500000000.f;
	float C = 1.f;

	printf("A + (B + C) is equal to %f\n", A + (B + C));
	printf("(A + B) + C is equal to %f\n", (A + B) + C);
	printf("A + B + C is equal to %f\n", A + B + C);

	return EXIT_SUCCESS;
}

//	Explanation for above output:

//	A + (B + C):
// ----------------
//	(B + C) = 500000000.0 + 1.0
//			= 500000000.0
//	(rounded off during floating point arithmetic)

//	A + (B + C) = -500000000.0 + 500000000.0 
//			= 0.000000
//
//	(A + B) + C:
// -----------------
//	(A + B) = -500000000.0 + 500000000.0 
//			= 0.000000
//
//	(A + B) + C = 0.000000 + 1 
//			= 1.000000

