#include <stdio.h>
#include <stdlib.h>

int main(void) {
	int si = -20;
	long sl = -20;
	long long sll = -20;
	unsigned int ui = 10;
	unsigned long ul = 10;

	//	si (-20) is converted to unsigned int (2a)
	printf("si < ui = %d\n", si < ui); // 0
	printf("si + ui = %u\n", si + ui); // 4294967286
	printf("\n");

	//	si (-20) is converted to unsigned long (2a)
	printf("si < ul = %d\n", si < ul);  // 0
	printf("si + ul = %lu\n", si + ul); // 18446744073709551606
	printf("\n");

	//	ui is converted to long (if long includes all unsigned int values),
	//	otherwise ui and si are converted to unsigned long (with effect as
	//	above) (2b)
	printf("sl < ui = %d\n", sl < ui);  // 1
	printf("sl + ui = %ld\n", sl + ui); // -10
	printf("\n");

	//	sll and ul are converted to unsigned long long (if long long does not
	//	include all unsigned long values), otherwise ul is converted to long
	//	long) (2b)
	printf("sll < ul = %d\n", sll < ul);   // 0
	printf("sll + ul = %llu\n", sll + ul); // 18446744073709551606
	printf("\n");

	return EXIT_SUCCESS;
}

